{***********************************************************************

Copyright (C) 2016 Bergen A van <x1@ziggo.nl>

This file is part of P3.

P3 is free software: you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free
Software Foundation, either version 3 of the License, or (at your
option) any later version.

P3 is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details.

You should have received a copy of the GNU General Public License along
with this program. If not, see <http://www.gnu.org/licenses/>.

***********************************************************************}

UNIT p3m2; { element = p3m2_Tweatherreport }

{$I+} {$R+}

INTERFACE

USES p3m1; { date }

CONST

p3m2_Cmaxtemperature=600; { in 0.1 degrees Celsius }
p3m2_Cmintemperature=-p3m2_Cmaxtemperature;

TYPE

p3m2_Tstationnumber=100..999;

p3m2_Ttemperature=p3m2_Cmintemperature..p3m2_Cmaxtemperature;

p3m2_Tweatherelement=RECORD
                       Ft1,Ft2,Ft3:p3m2_Ttemperature;
                     END;

p3m2_Tweatherreport=RECORD
                      Fstationnumber:p3m2_Tstationnumber;
                      Fdate         :p3m1_Tdate;
                      Felement      :p3m2_Tweatherelement
                    END;

p3m2_Tweatherreportkey=RECORD
                         Fstationnumber:p3m2_Tstationnumber;
                         Fdate         :p3m1_Tdate
                       END;

{**********************************************************************}

p3m2_Telement=p3m2_Tweatherreport;
p3m2_Tkey    =p3m2_Tweatherreportkey;

PROCEDURE p3m2_Rgetkey(    x:p3m2_Telement;
                       VAR y:p3m2_Tkey);

FUNCTION p3m2_Rlesskey(y1,y2:p3m2_Tkey):BOOLEAN;
FUNCTION p3m2_Rsamekey(y1,y2:p3m2_Tkey):BOOLEAN;
FUNCTION p3m2_Rkeyorder(y1,y2:p3m2_Tkey):BOOLEAN;
FUNCTION p3m2_Relementorder(x1,x2:p3m2_Telement):BOOLEAN;

{**********************************************************************}

IMPLEMENTATION

PROCEDURE p3m2_Rgetkey(    x:p3m2_Telement;
                       VAR y:p3m2_Tkey);

  BEGIN
    y.Fstationnumber:=x.Fstationnumber;
    y.Fdate:=x.Fdate
  END;

FUNCTION p3m2_Rlesskey(y1,y2:p3m2_Tkey):BOOLEAN;

  BEGIN
    p3m2_Rlesskey:=(y1.Fstationnumber<y2.Fstationnumber) OR ((y1.Fstationnumber=y2.Fstationnumber) AND p3m1_Rlessdate(y1.Fdate,y2.Fdate))
  END;

FUNCTION p3m2_Rsamekey(y1,y2:p3m2_Tkey):BOOLEAN;

  BEGIN
    p3m2_Rsamekey:=(y1.Fstationnumber=y2.Fstationnumber) AND p3m1_Rsamedate(y1.Fdate,y2.Fdate)
  END;

FUNCTION p3m2_Rkeyorder(y1,y2:p3m2_Tkey):BOOLEAN;

  BEGIN
    p3m2_Rkeyorder:=p3m2_Rlesskey(y1,y2)
  END;

FUNCTION p3m2_Relementorder(x1,x2:p3m2_Telement):BOOLEAN;

  VAR y1,y2:p3m2_Tkey;

  BEGIN
    p3m2_Rgetkey(x1,y1);
    p3m2_Rgetkey(x2,y2);
    p3m2_Relementorder:=p3m2_Rkeyorder(y1,y2)
  END;

END.
