{***********************************************************************

Copyright (C) 2016 Bergen A van <x1@ziggo.nl>

This file is part of P3.

P3 is free software: you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free
Software Foundation, either version 3 of the License, or (at your
option) any later version.

P3 is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details.

You should have received a copy of the GNU General Public License along
with this program. If not, see <http://www.gnu.org/licenses/>.

***********************************************************************}

UNIT p3m3; { element = p3m3_Ttransaction }

{$I+} {$R+}

INTERFACE

USES p3m2; { element = p3m2_Tweatherreport }

CONST p3m3_Cmaxtransactionnumber=100000;

TYPE

p3m3_Ttransactionnumber=0..p3m3_Cmaxtransactionnumber;

p3m3_Tevent=(addition,deletion);

p3m3_Ttransaction=RECORD
                     Fweatherreportkey :p3m2_Tweatherreportkey;
                     Ftransactionnumber:p3m3_Ttransactionnumber;
                     CASE Fevent       :p3m3_Tevent OF
                       addition        :(Felement:p3m2_Tweatherelement);
                       deletion        :()
                  END;

p3m3_Ttransactionkey=RECORD
                       Fweatherreportkey :p3m2_Tweatherreportkey;
                       Ftransactionnumber:p3m3_Ttransactionnumber
                     END;

{**********************************************************************}

p3m3_Telement=p3m3_Ttransaction;
p3m3_Tkey    =p3m3_Ttransactionkey;

PROCEDURE p3m3_Rgetkey(    x:p3m3_Telement;
                       VAR y:p3m3_Tkey);

FUNCTION p3m3_Rlesskey(y1,y2:p3m3_Tkey):BOOLEAN;
FUNCTION p3m3_Rsamekey(y1,y2:p3m3_Tkey):BOOLEAN;
FUNCTION p3m3_Rkeyorder(y1,y2:p3m3_Tkey):BOOLEAN;
FUNCTION p3m3_Relementorder(x1,x2:p3m3_Telement):BOOLEAN;

{**********************************************************************}

IMPLEMENTATION

PROCEDURE p3m3_Rgetkey(    x:p3m3_Telement;
                       VAR y:p3m3_Tkey);

  BEGIN
    y.Fweatherreportkey:=x.Fweatherreportkey;
    y.Ftransactionnumber:=x.Ftransactionnumber
  END;

FUNCTION p3m3_Rlesskey(y1,y2:p3m3_Tkey):BOOLEAN;

  BEGIN
    p3m3_Rlesskey:=p3m2_Rlesskey(y1.Fweatherreportkey,y2.Fweatherreportkey)
  END;

FUNCTION p3m3_Rsamekey(y1,y2:p3m3_Tkey):BOOLEAN;

  BEGIN
    p3m3_Rsamekey:=p3m2_Rsamekey(y1.Fweatherreportkey,y2.Fweatherreportkey);
  END;

FUNCTION p3m3_Rkeyorder(y1,y2:p3m3_Tkey):BOOLEAN;

  BEGIN
    p3m3_Rkeyorder:=p3m3_Rlesskey(y1,y2) OR (p3m3_Rsamekey(y1,y2) AND (y1.Ftransactionnumber<y2.Ftransactionnumber))
  END;

FUNCTION p3m3_Relementorder(x1,x2:p3m3_Telement):BOOLEAN;

  VAR y1,y2:p3m3_Tkey;

  BEGIN
    p3m3_Rgetkey(x1,y1);
    p3m3_Rgetkey(x2,y2);
    p3m3_Relementorder:=p3m3_Rkeyorder(y1,y2)
  END;

END.
